<%@ Language=VBScript %>
<%
'*************************************************************************
' DO NOT MODIFY THIS SCRIPT IF YOU WANT UPDATES TO WORK!
' Function : Gateway between HTTP and HTTPS sessions.
'          : This script must always be run under an HTTP session. It 
'          : will redirect to the target environment as required.
' Product  : Shopping Tree Store Frontend
' Version  : 3.3
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*************************************************************************
'	Date					Description
' 01/13/06	Add test for language code in random key
' 02/20/06	Add code so that 2.5 orders will get default currency / language
' 08/24/06	Fixed security issue.
'*************************************************************************
Option explicit
Response.Buffer = true
%>
<!--#include file="_INCconfig_.asp"-->
<!--#include file="_INCappDBConn_.asp"-->
<!--#include file="_INCappFunctions_.asp"-->
<!--#include file="_INCLanguage_.asp"-->
<%
'Variables
dim action
dim randomKey
dim deletedItems
dim currencyCode
dim orderStatus

'Database
dim mySQL
dim conntemp
dim rstemp
dim rstemp2

'Session
dim idOrder
dim idCust


'*************************************************************************

'Open Database Connection
call openDb()

'Store Configuration
if loadConfig() = false then
	call errorDB(LangText("ErrConfig",""),"")
end if

'Check Action Indicator
action = lCase(Request.QueryString("action"))
if  action <> "logon" _
and action <> "logonaff" _
and action <> "checkout" _
and action <> "save" _
and action <> "logoff" _
and action <> "setid" _
and action <> "retrieve" then
	response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrAction",""))
end if

'********************************
'* HTTP -> HTTPS (10_logon.asp) *
'********************************
if action = "logon" _
or action = "logonaff" _
or action = "checkout" _
or action = "save" then

	'Get idOrder from Session
	idOrder = sessionCart()
	'Create Random Key to ensure order number is not tampered with
	currencyCode = request.cookies("CurrencyCode")
	randomKey = currencyCode & request.cookies("language") & rndKey(99999999)
	'If active shopping cart exists, save random key to order
	if not isNull(idOrder) then
		mySQL = "UPDATE cartHead " _
		      & "SET    randomKey = '" & validSQL(randomKey,"A") & "' " _
			  & "WHERE  idOrder = "    & validSQL(idOrder,"I")
		set rsTemp = openRSexecute(mySQL)
		call closeRS(rsTemp)	
	end if
	
	'Close DB Connection
	call closedb()

	'Redirect to "10_logon.asp"
	Response.Redirect urlSSL & "10_Logon.asp?action=" & action & "&idOrder=" & idOrder & "&randomKey=" & randomKey
		
'****************************
'* HTTPS -> HTTP (cart.asp) *
'****************************
elseif action = "retrieve" then
	
	'Validate Order Number passed via QueryString
	idOrder = Request.QueryString("idOrder")
	if not isNumeric(idOrder) then
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvOrder",""))
	end if

	'Validate Random Key passed via QueryString
	randomKey = Request.QueryString("randomKey")
	if not isNumeric(mid(randomKey,6)) then
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvRandKey",""))
	end if

	'Validate Order/Random Key/Status combination on DB
	mySQL = "SELECT idOrder, randomKey, orderStatus " _
		  & "FROM   cartHead " _
		  & "WHERE  idOrder = "    & validSQL(idOrder,"I")   & " " _
		  & "AND    randomKey = '" & validSQL(randomKey,"A") & "' " _
		  & "AND   (orderStatus = 'U' OR orderStatus = 'S' OR orderStatus = '0') "
	set rsTemp = openRSexecute(mySQL)
	if rstemp.eof then
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrInvOrder",""))
	end if
	orderStatus = rsTemp("orderStatus")
	call closeRS(rsTemp)

	'Set Session Value
	session(storeID & "idOrder") = idOrder
	
	mySQL = "SELECT Code " _
	      & "FROM [currency] " _
	      & "WHERE code = '" & mid(randomKey,1,3) & "';"
	set rsTemp2 = openRSexecute(mySQL)
	if Not rsTemp2.eof then
		response.cookies("CurrencyCode") = mid(randomKey,1,3)
	else
		response.cookies("CurrencyCode") = currencyDefault
	end if
	closeRS(rsTemp2)
	
	mySQL = "SELECT idLang " _
      & "FROM languages_known " _
      & "WHERE idLang = '" & mid(randomKey,4,2) & "';"
	set rsTemp2 = openRSexecute(mySQL)
	if Not rsTemp2.eof then
		response.cookies("language") = mid(randomKey,4,2)
	else
		response.cookies("language") = languageDefault
	end if
	closeRS(rsTemp2)
	
	'Check quantity against available stock if stock level checking 
	'is enabled.
	if pHideAddStockLevel <> -1 then
		'See if quantities of the product are still available
		mySQL = "SELECT idproduct,description,sku,quantity " _
			  & "FROM   cartRows " _
			  & "WHERE  idOrder = "    & validSQL(idOrder,"I")   & " " 
		set rsTemp2 = openRSexecute(mySQL)
		do while not rsTemp2.eof
			mySQL = "SELECT stock " _
			      & "FROM products " _
			      & "WHERE idProduct = " & validSQL(rsTemp2("idProduct"),"I") & "; "
			set rsTemp = openRSexecute(mySQL)
			
			if rsTemp2("quantity") > rsTemp("stock") then
				deletedItems = deletedItems & rsTemp2("description") & " (" & rsTemp2("sku") & ") " & LangText("ErrOutStock","Prior quantity exceeded available stock - quantity reduce to zero.") & "<br>"
				closeRS(rsTemp)
				mySQL = "UPDATE cartrows " _
				      & "SET quantity = 0 " _
				      & "WHERE idOrder = " & validSQL(idOrder,"I") & " " _
					  & "AND   idProduct = " & validSQL(rsTemp2("idProduct"),"I") & ";"
				set rsTemp = openRSexecute(mySQL)
				closeRS(rsTemp)
			end if
			rsTemp2.movenext
		loop
	end if
	'Close DB Connection
	call closedb()

	'Redirect to "cart.asp"
	Response.Redirect urlNonSSL & "cart.asp?action=retrieve&deletedItems=" & server.URLEncode(deletedItems)
elseif action = "logoff" then
	response.cookies(storeID & "idCust") = ""			
	session(storeID & "idCust") = null
	Response.Redirect "sysMsg.asp?msg=" & server.URLEncode(LangText("GenLogoffMsg",""))
end if

'**********************************************************************
'Generate a Random Key
'**********************************************************************
function rndKey(upperbound)
	randomize
	rndKey = DatePart("y",now()) _
		   & DatePart("h",now()) _
		   & DatePart("n",now()) _
		   & DatePart("s",now()) _
		   & Int(upperbound * Rnd + 1)
end function

%>