<%
'*************************************************************************
' DO NOT MODIFY THIS SCRIPT IF YOU WANT UPDATES TO WORK!
' Function : Functions used for states and countries
' Product  : Shopping Tree Store Frontend
' Version  : 3.3
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*************************************************************************

'*************************************************************************
'Variables
'*************************************************************************

dim countryArr
dim stateArr
dim municipalityArr

'*********************************************************************
'Validate State & Country Code combination
'*********************************************************************
function validLoc(locState,locCountry)
	
	dim mySQL, rsTemp
	'Assume error until proven otherwise
	validLoc = false
	
	'Do basic checks
	if len(locCountry) = 0 then
		exit function		
	end if

	'Do database checks
	if len(locState) = 0 then ' if no state code then make sure there are none listed
		'Check if State/Province is required for the Country
		mySQL = "SELECT COUNT(*) as recCount " _
			  & "FROM States " _
			  & "WHERE Status = 'A' " _
			  & "AND idCountry  IN " _
			  	  & "(SELECT idCountry " _
			  	  & "FROM Country " _
			  	  & "WHERE CountryCode = '" & validSQL(locCountry,"A") & "' )"
		set rsTemp = openRSexecute(mySQL)
		if rsTemp("recCount") = 0 then	'No states defined for Country
			validLoc = true
		end if
		call closeRS(rsTemp)
	else
		'Check State/Country Combo is valid
		mySQL = "SELECT count(*) as recCount " _
			  & "FROM Country " _
			  & "WHERE Status = 'A' " _
			  & "AND CountryCode = '" & validSQL(locCountry,"A") & "' " _
			  & "AND idCountry IN " _
				  & "(SELECT idCountry " _
				  & "FROM States " _
				  & "WHERE Status = 'A' " _
				  & "AND StateCode = '" & validSQL(locState,"A") & "')" 
		set rsTemp = openRSexecute(mySQL)
		if rsTemp("recCount") => 1  then			'Valid State/Country combo
			validLoc = true
		end if
		call closeRS(rsTemp)
	end if

end function

'*********************************************************************
'Create City array
'*********************************************************************
function getMunicipalityArray()

	dim mySQL,rsTemp

	mySQL="SELECT MunicipalityName " _
	    & "FROM   Municipality " _
		& "WHERE  Status = 'A' " _
	    & "ORDER BY MunicipalityName"
	set rsTemp = openRSexecute(mySQL)
	if not rsTemp.EOF then
		municipalityArr = rsTemp.getRows()
	end if
	call closeRS(rsTemp)

end function

'*********************************************************************
'Create State / Province array
'*********************************************************************
function getStateArray()

	dim mySQL,rsTemp

	mySQL="SELECT StateName,StateCode " _
	    & "FROM   States " _
		& "WHERE  Status = 'A' " _
	    & "ORDER BY idCountry, StateName"
	set rsTemp = openRSexecute(mySQL)
	if not rsTemp.EOF then
		stateArr = rsTemp.getRows()
	end if
	call closeRS(rsTemp)

end function
'*********************************************************************
'Create Country array
'*********************************************************************
function getCountryArray()

	dim mySQL,rsTemp
	
	mySQL="SELECT CountryName,CountryCode " _
	    & "FROM   Country " _
	    & "WHERE  Status = 'A' " _
	    & "ORDER BY CountryName"
	set rsTemp = openRSexecute(mySQL)
	if not rsTemp.EOF then
		countryArr = rsTemp.getRows()
	end if
	call closeRS(rsTemp)

end function

'*********************************************************************
'Create drop-down list of Municipalities
'*********************************************************************
sub listMunicipalities(fieldName,fieldVal,fieldVal2)
	dim row
	if isArray(stateArr) then %>
	<SELECT name="<%=fieldName%>" size=1>
		<OPTION value=""></OPTION>
<%		for row = 0 to UBound(stateArr,1) %>
			<OPTION VALUE="<%=municipalityArr(0,row)%>" <%=checkMatch(fieldVal ,municipalityArr(0,row))%>><%=trim(municipalityArr(0,row)) %></OPTION>
<%		next %>
	</SELECT>
<%	end if
end sub


'*********************************************************************
'Create drop-down list of States
'*********************************************************************
sub listStates(fieldName,fieldVal,fieldVal2)
	dim row
	if isArray(stateArr) then %>
	<SELECT name="<%=fieldName%>" size=1>
		<OPTION value=""></OPTION>
<%		for row = 0 to UBound(stateArr,2) %>
			<OPTION VALUE="<%=stateArr(1,row)%>" <%=checkMatch(fieldVal ,stateArr(1,row))%>><%=trim(stateArr(0,row)) & " (" & stateArr(1,row) & ")"%></OPTION>
<%		next %>
	</SELECT>
<%	end if
end sub
'*********************************************************************
'Create drop-down list of Countries
'*********************************************************************
sub listCountries(fieldName,fieldVal)
	dim row
	if isArray(countryArr) then %>
	<SELECT name="<%=fieldName%>" size=1>
		<OPTION value=""></OPTION>
<%		for row = 0 to UBound(countryArr,2) %>
			<OPTION VALUE="<%=countryArr(1,row)%>" <%=checkMatch(fieldVal,countryArr(1,row))%>><%=trim(countryArr(0,row))%></OPTION>
<%		next %>
	</SELECT>
<%	end if
end sub
%>